function [ T, W, X] = colinear_RLS(w0,wstar,Bx,eta,tol)
T = 0;
w = w0;
W = w0;
X = [];
y = 1;
d = length(w0);
while norm(w-wstar)^2>tol
    T = T + 1;
    theta = (wstar-w)'*w/norm(wstar-w);
    if (wstar-w)'*w>0
        a = min(Bx,1/(2*theta));
    else
        a = Bx;
    end
    x = a*(wstar-w)/norm(wstar-w);
    if eta*(1-a*theta)*a>=norm(wstar-w)
        w = wstar;
    else
    w = w + eta*(y-w'*x)*x;
    end
    X = [X,x];
    W = [W,w];
end
end

