function [ T, W, X] = greedy_RLS(w0,wstar,Bx,eta,tol)
T = 0;
w = w0;
W = w0;
X = [];
y = 1;
d = length(w0);
while norm(w-wstar)^2>tol
    T = T + 1;
    options = optimoptions('fmincon','Display','notify','MaxFunctionEvaluations',100000);
    x = fmincon(@(x)greedy_RLS_obj(x,y,w,wstar,eta),zeros(d,1),[],[],[],[],[],[],@(x)greedy_nonlcon(x,Bx),options);
    w = w + eta*(y-w'*x)*x;
    X = [X,x];
    W = [W,w];
end
end

